/*
 * hooks.c
 *
 * You can plug your own stuff in here!
 */

#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <time.h>
#include <ctype.h>
#include <string.h>
#include "citadel.h"

extern struct config config;
FILE *monfp;


int posbuf[256];

int get_pos(int sess) {
	int a, b, ok;

	for (a=3; a<24; ++a) {
		ok = 1;
		for (b=0; b<256; ++b) {
			if (posbuf[b] == a) ok = 0;
			}
		if (ok) {
			posbuf[sess] = a;
			return(a);
			}
		}
	return(24);
	}

/*
 * hook_init() is called at server startup.
 */
void hook_init() {
	time_t now;
	int a;

	nice(-19);	/* We run our Citadels at top priority! */

	for (a=0; a<256; ++a) posbuf[a] = 0;

	time(&now);
	monfp = NULL;
	if (!strcmp(config.c_nodename, "uncnsrd")) {
		system("exec /usr/bin/reset </dev/tty7 >/dev/tty7 2>/dev/tty7");
		monfp = fopen("/dev/tty7", "w");
		}
	if (!strcmp(config.c_nodename, "charis")) {
		system("exec /usr/bin/reset </dev/tty9 >/dev/tty9 2>/dev/tty9");
		monfp = fopen("/dev/tty9", "w");
		}
	if (monfp == NULL) monfp = fopen("/dev/null", "w");
	fprintf(monfp, "%c[2J%c[1;60H0123456789\n\n", 27, 27);
	fprintf(monfp, "%c[H%s: Up since %s\n",
		27, config.c_humannode, asctime(localtime(&now)));
	}

/* 
 * hook_start_session() is called when a new session is started.
 */
void hook_start_session(session_num)
int session_num; {
	
	fprintf(monfp,"%c[%d;1H%3d Session starting\n",
		27, get_pos(session_num), session_num);
	}

/* 
 * hook_end_session() is called when a session terminates.
 */
void hook_end_session(session_num)
int session_num; {
	fprintf(monfp,"%c[%d;1H%80s\n",
		27, (posbuf[session_num]), "");
	posbuf[session_num] = 0;
	}

/*
 * hook_command_received() is called whenever a command is received from
 * the client, but before executing the command.
 */
void hook_command_received(session_num, cmdbuf)
int session_num;
char *cmdbuf; {
	char buf[5];

	strncpy(buf, cmdbuf, 4);
	buf[4] = 0;
	fprintf(monfp,"%c[%d;75H%c[31m%4s%c[0m\n",
		27, (posbuf[session_num]), 27, buf, 27);
	}

/*
 * hook_crit_get() is called when a session is about to enter a critical
 * section, before a semaphore is obtained.
 */
void hook_crit_get(session_num, which_one)
int session_num;
int which_one; {
	fprintf(monfp,"%c[%d;%dH+\n",
		27, (posbuf[session_num]), (which_one+60) );
	}

/*
 * hook_crit_got() is called when a session is about to enter a critical
 * section, after a semaphore is obtained.
 */
void hook_crit_got(session_num, which_one)
int session_num;
int which_one; {
	fprintf(monfp,"%c[%d;%dH*\n",
		27, (posbuf[session_num]), (which_one+60) );
	}

/*
 * hook_crit_end() is called when a session is leaving a critical section.
 */
void hook_crit_end(session_num, which_one)
int session_num;
int which_one; {
	fprintf(monfp,"%c[%d;%dH_\n",
		27, (posbuf[session_num]), (which_one+60) );
	}

/*
 * hook_user_login() is called when a user logs in.
 */
void hook_user_login(session_num, user_name)
int session_num;
char *user_name; {
	fprintf(monfp,"%c[%d;5H%c[34m%-25s%c[0m\n",
		27, (posbuf[session_num]), 27, user_name, 27);
	}

/* 
 * hook_room_name() is called when a user changes rooms.
 */
void hook_room_name(session_num, room_name)
int session_num;
char *room_name; {
	fprintf(monfp,"%c[%d;30H%c[32m%-25s%c[0m\n",
		27, (posbuf[session_num]), 27, room_name, 27);
	}

/*
 * hook_cleanup() is called when the server is about to terminate.
 */
void hook_cleanup() {
	fprintf(monfp, "%c[2J%c[H --- Server Terminated ---\n", 27, 27);
	fclose(monfp);
	}

