#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <fcntl.h>
#include <time.h>
#include <ctype.h>
#include <string.h>
#include <syslog.h>
#include <pthread.h>
#include "citadel.h"
#include "server.h"
#include <errno.h>
#include "proto.h"

#define MSGS_ALL	0
#define MSGS_OLD	1
#define MSGS_NEW	2
#define MSGS_FIRST	3
#define MSGS_LAST	4
#define MSGS_GT		5

extern struct config config;
int twitroom=-1;


/*
 * Aliasing for network mail.
 * (Error messages have been commented out, because this is a server.)
 */
int alias(char *name)		/* process alias and routing info for mail */
             {
	FILE *fp;
	int a,b;
	char aaa[300],bbb[300];
	
	fp=fopen("network/mail.aliases","r");
	if (fp==NULL) fp=fopen("/dev/null","r");
	if (fp==NULL) return(M_ERROR);
GNA:	strcpy(aaa,""); strcpy(bbb,"");
	do {
		a=getc(fp);
		if (a==',') a=0;
		if (a>0) {
			b=strlen(aaa);
			aaa[b]=a;
			aaa[b+1]=0;
			}
		} while(a>0);
	do {
		a=getc(fp);
		if (a==10) a=0;
		if (a>0) {
			b=strlen(bbb);
			bbb[b]=a;
			bbb[b+1]=0;
			}
		} while(a>0);
	if (a<0) {
		fclose(fp);
		goto DETYPE;
		}
	if (strucmp(name,aaa)) goto GNA;
	fclose(fp);
	strcpy(name,bbb);
	/* cprintf("*** Mail is being forwarded to %s\n",name); */

DETYPE:	/* determine local or remote type, see citadel.h */
	for (a=0; a<strlen(name); ++a) if (name[a]=='!') return(M_INTERNET);
	for (a=0; a<strlen(name); ++a)
		if (name[a]=='@')
			for (b=a; b<strlen(name); ++b)
				if (name[b]=='.') return(M_INTERNET);
	b=0; for (a=0; a<strlen(name); ++a) if (name[a]=='@') ++b;
	if (b>1) {
		/* cprintf("Too many @'s in address\n"); */
		return(M_ERROR);
		}
	if (b==1) {
		for (a=0; a<strlen(name); ++a)
			if (name[a]=='@') strcpy(bbb,&name[a+1]);
		while (bbb[0]==32) strcpy(bbb,&bbb[1]);
		fp = fopen("network/mail.sysinfo","r");
		if (fp==NULL) return(M_ERROR);
GETSN:		do {
			a=getstring(fp,aaa);
			} while ((a>=0)&&(strucmp(aaa,bbb)));
		a=getstring(fp,aaa);
		if (!strncmp(aaa,"use ",4)) {
			strcpy(bbb,&aaa[4]);
			fseek(fp,0L,0);
			goto GETSN;
			}
		fclose(fp);
		if (!strncmp(aaa,"uum",3)) {
			strcpy(bbb,name);
			for (a=0; a<strlen(bbb); ++a) {
				if (bbb[a]=='@') bbb[a]=0;
				if (bbb[a]==' ') bbb[a]='_';
				}
			while(bbb[strlen(bbb)-1]=='_') bbb[strlen(bbb)-1]=0;
			sprintf(name,&aaa[4],bbb);
			return(M_INTERNET);
			}
		if (!strncmp(aaa,"bin",3)) {
			strcpy(aaa,name); strcpy(bbb,name);
			while (aaa[strlen(aaa)-1]!='@') aaa[strlen(aaa)-1]=0;
			aaa[strlen(aaa)-1]=0;
			while (aaa[strlen(aaa)-1]==' ') aaa[strlen(aaa)-1]=0;
			while (bbb[0]!='@') strcpy(bbb,&bbb[1]);
			strcpy(bbb,&bbb[1]);
			while (bbb[0]==' ') strcpy(bbb,&bbb[1]);
			sprintf(name,"%s @%s",aaa,bbb);
			return(M_BINARY);
			}
		return(M_ERROR);
		}
	return(M_LOCAL);
	}


void get_mm(void) {
	FILE *fp;

	fp=fopen("MMstructure","r");
	fread((char *)&CC->msgmain,sizeof(struct msgmain),1,fp);
	fclose(fp);
	}

/*
 * cmd_msgs()  -  get list of message #'s in this room
 */
void cmd_msgs(char *cmdbuf)
{
	int a;
	int mode;
	char which[256];
	int cm_howmany;
	long cm_gt;

	extract(which,cmdbuf,0);

	mode = MSGS_ALL;
	strcat(which,"   ");
	if (!struncmp(which,"OLD",3))	mode = MSGS_OLD;
	if (!struncmp(which,"NEW",3))	mode = MSGS_NEW;
	if (!struncmp(which,"FIRST",5))	{
		mode = MSGS_FIRST;
		cm_howmany = extract_int(cmdbuf,1);
		}
	if (!struncmp(which,"LAST",4))	{
		mode = MSGS_LAST;
		cm_howmany = extract_int(cmdbuf,1);
		}
	if (!struncmp(which,"GT",2))	{
		mode = MSGS_GT;
		cm_gt = extract_long(cmdbuf,1);
		}

	if ((!(CC->logged_in))&&(!(CC->internal_pgm))) {
		cprintf("%d not logged in\n",ERROR+NOT_LOGGED_IN);
		return;
		}
	if (CC->curr_rm < 0) {
		cprintf("%d no room\n",ERROR);
		return;
		}
	get_mm();
	get_fullroom(&CC->fullroom,CC->curr_rm);
	getuser(&CC->usersupp,CC->curr_user);
	cprintf("%d messages...\n",LISTING_FOLLOWS);
	for (a=0; a<MSGSPERRM; ++a) 
	    if ( (CC->fullroom.FRnum[a] >= CC->msgmain.MMlowest)
	       && (CC->fullroom.FRnum[a] >=0)
	       && ( 

(mode==MSGS_ALL)
|| ((mode==MSGS_OLD) && (CC->fullroom.FRnum[a] <= CC->usersupp.lastseen[CC->curr_rm]))
|| ((mode==MSGS_NEW) && (CC->fullroom.FRnum[a] > CC->usersupp.lastseen[CC->curr_rm]))
|| ((mode==MSGS_NEW) && (CC->fullroom.FRnum[a] >= CC->usersupp.lastseen[CC->curr_rm])
		     && (CC->usersupp.flags & US_LASTOLD))
|| ((mode==MSGS_LAST)&& (a>=(MSGSPERRM-cm_howmany)))
|| ((mode==MSGS_FIRST)&&(a<cm_howmany))
|| ((mode==MSGS_GT) && (CC->fullroom.FRnum[a] > cm_gt))

			)
		)
		cprintf("%ld\n",CC->fullroom.FRnum[a]);
	cprintf("000\n");
	}



/* 
 * help_subst()  -  support routine for help file viewer
 */
void help_subst(char *strbuf, char *source, char *dest)
{
	char workbuf[256];
	int p;

	while (p=pattern2(strbuf,source), (p>=0)) {
		strcpy(workbuf,&strbuf[p+strlen(source)]);
		strcpy(&strbuf[p],dest);
		strcat(strbuf,workbuf);
		}
	}


void do_help_subst(char *buffer)
{
	char buf2[16];

	help_subst(buffer,"^nodename",config.c_nodename);
	help_subst(buffer,"^humannode",config.c_humannode);
	help_subst(buffer,"^fqdn",config.c_fqdn);
	help_subst(buffer,"^username",CC->usersupp.fullname);
	sprintf(buf2,"%ld",CC->usersupp.eternal);
	help_subst(buffer,"^usernum",buf2);
	help_subst(buffer,"^sysadm",config.c_sysadm);
	help_subst(buffer,"^variantname",CITADEL);
	sprintf(buf2,"%d",config.c_maxsessions);
	help_subst(buffer,"^maxsessions",buf2);
	}



/*
 * fmout()  -  Citadel text formatter and paginator.
 *             Although the original purpose of this routine was to format
 *             text to the reader's screen width, all we're really using it
 *             for here is to format text out to 80 columns before sending it
 *             to the client.  The client software may reformat it again.
 */
void fmout(int width, FILE *fp, char subst)
          		/* screen width to use */
         		/* where are we going to get our text from? */
           		/* nonzero if we should use hypertext mode */
	{
	int a,b,c,real,old;
	char aaa[140];
	char buffer[256];
	
	strcpy(aaa,""); old=255;
	strcpy(buffer,"");
	c=1; /* c is the current pos */

FMTA:	if (subst) {
		while ( (!feof(fp)) && (strlen(buffer)<126) ) {
			a=getc(fp);
			buffer[strlen(buffer)+1] = 0;
			buffer[strlen(buffer)] = a;
			}

		if (buffer[0]=='^') do_help_subst(buffer);

		buffer[strlen(buffer)+1] = 0;
		a=buffer[0];
		strcpy(buffer,&buffer[1]);
		}
	
	else a=getc(fp);

	old=real;
	real=a;
	if (a<=0) goto FMTEND;
	
	if ( ((a==13)||(a==10)) && (old!=13) && (old!=10) ) a=32;
	if ( ((old==13)||(old==10)) && (isspace(real)) ) {
		cprintf("\n");
		c=1;
		}
	if (a>126) goto FMTA;

	if (a>32) {
	if ( ((strlen(aaa)+c)>(width-5)) && (strlen(aaa)>(width-5)) )
		{ cprintf("\n%s",aaa); c=strlen(aaa); aaa[0]=0;
		}
	 b=strlen(aaa); aaa[b]=a; aaa[b+1]=0; }
	if (a==32) {
		if ((strlen(aaa)+c)>(width-5)) { 
			cprintf("\n");
			c=1;
			}
		cprintf("%s ",aaa); ++c; c=c+strlen(aaa);
		strcpy(aaa,"");
		goto FMTA;
		}
	if ((a==13)||(a==10)) {
		cprintf("%s\n",aaa);
		c=1;
		strcpy(aaa,"");
		goto FMTA;
		}
	goto FMTA;

FMTEND:	cprintf("\n");
	}


/*
 * get a message off disk.
 * 
 */
void output_message(char *msgid, int mode, int headers_only)
{
	long msg_num, msg_pos;
	int a,ch,och,len;
	FILE *msg;
	char format_type,anon_flag;
	char buf[1024];
	long msg_len;

	/* buffers needed for RFC822 translation */
	char suser[256];
	char luser[256];
	char snode[256];
	char lnode[256];
	char mid[256];
	long xtime;
	/* */

	msg_num = atol(msgid);
	msg_pos = (-1L);

	if ((!(CC->logged_in))&&(!(CC->internal_pgm))) {
		cprintf("%d Not logged in.\n",ERROR+NOT_LOGGED_IN);
		return;
		}
	if (CC->curr_rm < 0) {
		cprintf("%d No room selected.\n",ERROR);
		return;
		}

	if (msg_num < CC->msgmain.MMlowest) {
		cprintf("%d Message %ld is no longer online.\n",ERROR,msg_num);
		return;
		}

	for (a=0; a<MSGSPERRM; ++a) if (CC->fullroom.FRnum[a] == msg_num)
		msg_pos = CC->fullroom.FRpos[a];

	if (msg_pos < 0L) {
		get_fullroom(&CC->fullroom,CC->curr_rm);
		for (a=0; a<MSGSPERRM; ++a) if (CC->fullroom.FRnum[a] == msg_num)
			msg_pos = CC->fullroom.FRpos[a];
		}

	if (msg_pos < 0L) {
		cprintf("%d No message.\n",ERROR);
		return;
		}

	msg = fopen("msgmain","r");
	if (msg==NULL) {
		cprintf("%d Cannot open msgmain: %s\n",
			ERROR+INTERNAL_ERROR, strerror(errno));
		return;
		}

	fseek(msg,msg_pos,0);
	ch = wrapgetc(msg,config.c_msgbase);
	if (ch != 255) {
		cprintf("%d Can't find message!  pos = %ld\n",
			ERROR+INTERNAL_ERROR, msg_pos);
		fclose(msg);
		return;
		}

	anon_flag = wrapgetc(msg,config.c_msgbase);
	format_type = wrapgetc(msg,config.c_msgbase);


	/* this loop spews out the whole message if we're doing raw format */
	if (mode == MT_RAW) {

		/* Two reads will be required; one to measure the message,
		 * and one to output it.  Not to worry - Unix systems will
		 * keep the message in cache for the second read.  We lock
		 * the message base to prevent the size of the message from
		 * changing in case someone else is writing to it...
		 */
		begin_critical_section(S_MSGMAIN);
		msg_len = 3L;	/* 3 because we already read FF/anon/format */
		while(ch = wrapgetc(msg,config.c_msgbase), (ch!='M' && ch!=0)) {
			wrapgetfield(msg,buf,config.c_msgbase);
			if (ch != '#') {
				msg_len = msg_len + 1L + strlen(buf) + 1L;
				}
			}
		msg_len = msg_len + 1L;	/* the M field byte */
		do {
			ch = wrapgetc(msg,config.c_msgbase);
			++msg_len;
			} while (ch != 0);

		/* now spew! */
		cprintf("%d %ld\n", BINARY_FOLLOWS, msg_len);
		fseek(msg,msg_pos,0);
		for (a=0; a<3; ++a) {
			buf[0] = wrapgetc(msg,config.c_msgbase) ;
			client_write(buf, 1);
			}
		while(ch = wrapgetc(msg,config.c_msgbase), (ch!='M' && ch!=0)) {
			if (ch != '#')  {
				buf[0] = ch;
				client_write(buf, 1);
				}
			wrapgetfield(msg,buf,config.c_msgbase);
			if (ch != '#')  {
				client_write(buf, strlen(buf)+1);
				}
			}
		buf[0] = ch;
		client_write(buf, 1);
		do {
			buf[0] = wrapgetc(msg,config.c_msgbase);
			client_write(buf, 1);
			} while (buf[0] != 0);
		client_write(buf, 1);	/* the trailing null */

		end_critical_section(S_MSGMAIN);
		fclose(msg);
		return;
		}


	/* now for the user-mode message reading loops */
	cprintf("%d Message %ld:\n",LISTING_FOLLOWS,msg_num);

	if (mode == MT_CITADEL) cprintf("type=%d\n",format_type);

	if ( (anon_flag == MES_ANON) && (mode == MT_CITADEL) ) {
		cprintf("nhdr=yes\n");
		}

	/* begin header processing loop for Citadel message format */

	if (mode == MT_CITADEL) while(ch = wrapgetc(msg,config.c_msgbase), (ch!='M' && ch!=0)) {
		wrapgetfield(msg,buf,config.c_msgbase);

		if (ch=='A') {
			if (anon_flag==MES_ANON) cprintf("from=****");
			else if (anon_flag==MES_AN2) cprintf("from=anonymous");
			else cprintf("from=%s",buf);
			if ((is_room_aide()) && ((anon_flag == MES_ANON)
			   || (anon_flag == MES_AN2)))
				cprintf(" [%s]",buf);
			cprintf("\n");
			}
		else if (ch=='P') cprintf("path=%s\n",buf);
		else if (ch=='U') cprintf("subj=%s\n",buf);
		else if (ch=='I') cprintf("msgn=%s\n",buf);
		else if (ch=='H') cprintf("hnod=%s\n",buf);
		else if (ch=='O') cprintf("room=%s\n",buf);
		else if (ch=='N') cprintf("node=%s\n",buf);
		else if (ch=='R') cprintf("rcpt=%s\n",buf);
		else if (ch=='T') cprintf("time=%s\n",buf);
		/* else cprintf("fld%c=%s\n",ch,buf); */
		}

	/* begin header processing loop for RFC822 transfer format */

	strcpy(suser, "");
	strcpy(luser, "");
	strcpy(snode, NODENAME);
	strcpy(lnode, HUMANNODE);
	if (mode == MT_RFC822) while(ch = wrapgetc(msg,config.c_msgbase), (ch!='M' && ch!=0)) {
		wrapgetfield(msg,buf,config.c_msgbase);

		if (ch=='A') strcpy(luser, buf);
		else if (ch=='P') {
			cprintf("Path: %s\n",buf);
			for (a=0; a<strlen(buf); ++a) {
				if (buf[a] == '!') {
					strcpy(buf,&buf[a+1]);
					a=0;
					}
				}
			strcpy(suser, buf);
			}
		else if (ch=='U') cprintf("Subject: %s\n",buf);
		else if (ch=='I') strcpy(mid, buf);
		else if (ch=='H') strcpy(lnode, buf);
		else if (ch=='O') cprintf("X-Citadel-Room: %s\n",buf);
		else if (ch=='N') strcpy(snode, buf);
		else if (ch=='R') cprintf("To: %s\n",buf);
		else if (ch=='T')  {
			xtime = atol(buf);
			cprintf("Date: %s", asctime(localtime(&xtime)));
			}
		}

	if (mode == MT_RFC822) {
		if (!strucmp(snode, NODENAME)) {
			strcpy(snode, FQDN);
			}
		cprintf("Message-ID: <%s@%s>\n", mid, snode);
		cprintf("From: %s@%s (%s)\n",
			suser, snode, luser);
		cprintf("Organization: %s\n", lnode);
		}

	/* end header processing loop ... at this point, we're in the text */

	if (ch==0) {
		cprintf("text\n*** ?Message truncated\n000\n");
		fclose(msg);
		return;
		}

	if (headers_only) {
		/* give 'em a length */
		msg_len = 0L;
		while(och=ch, ch = wrapgetc(msg,config.c_msgbase), ch>0) {
			++msg_len;
			}
		cprintf("mlen=%ld\n", msg_len);
		cprintf("000\n");
		fclose(msg);
		return;
		}

	/* signify start of msg text */
	if (mode == MT_CITADEL)	cprintf("text\n");
	if (mode == MT_RFC822) cprintf("\n");

	/* If the format type on disk is 1 (fixed-format), then we want
	 * everything to be output completely literally ... regardless of
	 * what message transfer format is in use.
	 */
	if (format_type == 1) {
		och = 0;
		len = 0;
		while(och=ch, ch = wrapgetc(msg,config.c_msgbase), ch>0) {
			if (ch == 13) ch = 10;
			++len;
			if ((ch!=10)||(och!=10)) {
				cprintf("%c", ch);
				if (ch==10) len = 0;
				}
			if (len>=250) {
				len = 0;
				/* cprintf("%c", ch); */
				cprintf("%c", 10);
				}
			}
		if (len!=0) cprintf("%c", 10);
		}
	/* If the message on disk is format 0 (Citadel vari-format), we
	 * output using the formatter at 80 columns.  This is the final output
	 * form if the transfer format is RFC822, but if the transfer format
	 * is Citadel proprietary, it'll still work, because the indentation
	 * for new paragraphs is correct and the client will reformat the
	 * message to the reader's screen width.
	 */
	if (format_type == 0) {
		fmout(80,msg,0);
		}

	fclose(msg);

	/* now we're done */
	cprintf("000\n");
	}


/*
 * display a message (mode 0 - Citadel proprietary)
 */
void cmd_msg0(char *cmdbuf)
{
	char msgid[256];
	int headers_only = 0;

	extract(msgid,cmdbuf,0);
	headers_only = extract_int(cmdbuf,1);

	output_message(msgid,MT_CITADEL,headers_only);
	}


/*
 * display a message (mode 2 - RFC822)
 */
void cmd_msg2(char *cmdbuf)
{
	char msgid[256];
	int headers_only = 0;

	extract(msgid,cmdbuf,0);
	headers_only = extract_int(cmdbuf,1);

	output_message(msgid,MT_RFC822,headers_only);
	}

/* 
 * display a message (mode 3 - IGnet raw format - internal programs only)
 */
void cmd_msg3(char *cmdbuf)
{
	char msgid[256];
	int headers_only = 0;

	if (CC->internal_pgm == 0) {
		cprintf("%d This command is for internal programs only.\n",
			ERROR);
		return;
		}

	extract(msgid,cmdbuf,0);
	headers_only = extract_int(cmdbuf,1);

	output_message(msgid,MT_RAW,headers_only);
	}



/*
 * message base operation to send a message to the master file
 */
void send_message(char *filename, struct smreturn *retbuf, int generate_id)
                		/* tempfilename of proper message */
                        	/* return information */
                		/* set to 1 to generate an 'I' field */
{

int file,a,c,d;
long bb,dd,templen,hibytes,origpos,bytes_read,bytes_written;
char sbuf[BUFSIZ];
char mid[30];
FILE *fp,*fp2;

	begin_critical_section(S_MSGMAIN);
	file=open("MMstructure",O_RDWR);
	lseek(file,0L,0);
	a=read(file,&CC->msgmain,sizeof(struct msgmain));
	lseek(file,0L,0);
	close(file);

	origpos=CC->msgmain.MMcurpos;
	CC->msgmain.MMhighest = CC->msgmain.MMhighest + 1L;
	sprintf(mid,"%ld",CC->msgmain.MMhighest);

	/* Measure the message, also stripping out any '#' fields */
	bytes_read = 3L;
	bytes_written = 3L;
	lprintf(9, "Measuring the message\n");
	fp=fopen(filename,"rb+");
	fseek(fp, 3L, 0);
	while (fseek(fp, bytes_read, 0), c = getc(fp), (c != 'M') ) {
		lprintf(9, " - got field '%c'\n", c);
		wrapgetfield(fp, sbuf, config.c_msgbase);
		bytes_read = ftell(fp);
		if (c != '#') {
			fseek(fp, bytes_written, 0);
			fprintf(fp, "%c%s%c", c, sbuf, 0);
			bytes_written = ftell(fp);
			}
		}
	++bytes_read;
	fseek(fp, bytes_written, 0);
	putc('M', fp);
	++bytes_written;
	lprintf(9, " - doing text (%ld/%ld)\n", bytes_read, bytes_written);
	do {
		fseek(fp, bytes_read, 0);
		c = getc(fp);
		++bytes_read;
		fseek(fp, bytes_written, 0);
		putc(c, fp);
		++bytes_written;
		} while (c != 0);
	
	templen = bytes_written;
	fclose(fp);


	templen=templen+(2L*(long)strlen(mid))+4L;

	/* check for FF bytes, to determine how many msgs we're overwriting */
	hibytes=0L;
	fp=fopen("msgmain","rb");
	fseek(fp,CC->msgmain.MMcurpos,0);
	dd=ftell(fp);
	for (bb=0L; bb<templen; ++bb) {
		if (dd>=MM_FILELEN) {
			fseek(fp,0L,0);
			dd=0L;
			}
		c=getc(fp); ++dd;
		if (c>127) ++hibytes;	/* bump count if hi bit set */
		}
	fclose(fp);
	CC->msgmain.MMlowest = CC->msgmain.MMlowest + hibytes;

	fp=fopen("msgmain","r+");
	fseek(fp,CC->msgmain.MMcurpos,0);
	dd=ftell(fp);
	fp2=fopen(filename,"r");
	fread((char *)sbuf,3,1,fp2);
	fwrite((char *)sbuf,3,1,fp);
	fprintf(fp,"#%s%c",mid,0);

	/* 3 header + '#' + mid + 1 null */
	bytes_written = 5L + (long)strlen(mid);

	/* 'I' + mid + 1 null */
	if (generate_id == 1) {
		fprintf(fp,"I%s%c",mid,0);
		bytes_written = bytes_written + 2L + (long)strlen(mid);
		}

	while (bytes_written < templen) {
		d=getc(fp2);
		if (d<0) d=0;
		putc(d,fp);
		++dd;
		if (dd>=MM_FILELEN) {
			fseek(fp,0L,0);
			dd = 0L;
			}
		++bytes_written;
		}

	CC->msgmain.MMcurpos=ftell(fp);
	fclose(fp2);	/* done with temp file */
	fclose(fp);	/* done with master file */

	/* now update the message structure */
	file=open("MMstructure",O_RDWR);
	a=write(file,&CC->msgmain,sizeof(struct msgmain));
	close(file);

	retbuf->smnumber = CC->msgmain.MMhighest;
	retbuf->smpos=origpos;
	end_critical_section(S_MSGMAIN);
	}


void loadtroom(void) {
	struct quickroom qrbuf;
	int a;
	unsigned newflags;

	/* first try to locate the twit room */
	for (a=0; a<MAXROOMS; ++a) {
		getroom(&qrbuf,a);
		if (!strucmp(qrbuf.QRname,config.c_twitroom)) {
			twitroom = a;
			return;
			}
		}

	/* if not found, try to create it  -  put it in the last slot */
	twitroom = get_free_room_slot(-1);
	if (twitroom>=0) {
		newflags = create_room(twitroom,config.c_twitroom,0,"",0);
		return;
		}

	/* as a last resort, point to Aide> */
	twitroom = 2;
	}


/*
 * this is a simple file copy routine.
 */
void copy_file(char *from, char *to)
{
	FILE *ffp,*tfp;
	int a;

	ffp=fopen(from,"r");
	if (ffp==NULL) return;
	tfp=fopen(to,"w");
	if (tfp==NULL) {
		fclose(ffp);
		return;
		}
	while (a=getc(ffp), a>=0) {
		putc(a,tfp);
		}
	fclose(ffp);
	fclose(tfp);
	return;
	}



/*
 * message base operation to save a message and install its pointers
 */
void save_message(char *mtmp,	/* file containing proper message */
		char *rec,	/* Recipient (if mail) */
		char mtsflag,	/* 0 for normal, 1 to force Aide> room */
		int mailtype,	/* local or remote type, see citadel.h */
		int generate_id) /* set to 1 to generate an 'I' field */
{
	int a,e;
	struct usersupp tempUS;
	char aaa[100];
	struct smreturn smreturn;
	int hold_rm;

	send_message(mtmp,&smreturn,generate_id);
	hold_rm=(-1);

	/* if the user is a twit, move to the twit room for posting */
	if (TWITDETECT) if (CC->usersupp.axlevel==2) {
		if (twitroom<0) loadtroom();
		hold_rm=CC->curr_rm;
		CC->curr_rm=twitroom;
		}

	/* and if this message is destined for Aide> then go there */
	if (mtsflag) {
		hold_rm=CC->curr_rm;
		CC->curr_rm=2;
		}

	/* this call to usergoto() changes rooms if necessary.  It also
	   causes the latest fullroom structure to be read into memory */
	usergoto(CC->curr_rm,0);

	/* read in the quickroom record, obtaining a lock... */
	lgetroom(&CC->quickroom,CC->curr_rm);
	get_fullroom(&CC->fullroom,CC->curr_rm);

	for (a=0; a<(MSGSPERRM-1); ++a) {
		CC->fullroom.FRnum[a]=CC->fullroom.FRnum[a+1];
		CC->fullroom.FRpos[a]=CC->fullroom.FRpos[a+1];
		}
	CC->fullroom.FRnum[MSGSPERRM-1]=smreturn.smnumber;
	CC->fullroom.FRpos[MSGSPERRM-1]=smreturn.smpos;

	put_fullroom(&CC->fullroom,CC->curr_rm);

	/* update quickroom */
	CC->quickroom.QRhighest=CC->fullroom.FRnum[MSGSPERRM-1];
	lputroom(&CC->quickroom,CC->curr_rm);

	/* Bump this user's messages posted counter.  Also, if the user is a
	   twit, give them access to the twit room. */
	lgetuser(&CC->usersupp,CC->curr_user);
	CC->usersupp.posted = CC->usersupp.posted + 1;
	if (CC->curr_rm==twitroom) CC->usersupp.generation[twitroom]=CC->quickroom.QRgen;
	lputuser(&CC->usersupp,CC->curr_user);

	/* if mail, there's still more to do, if not, skip it */
	if ((CC->curr_rm!=1)||(mtsflag)) goto ENTFIN;

	/* network mail - send a copy to the network program */
	if (mailtype!=M_LOCAL) {
		sprintf(aaa,"./network/spoolin/nm.%d",getpid());
		copy_file(mtmp,aaa);
		system("exec nohup ./netproc >/dev/null 2>&1 &");
		}

	/* local mail - put a copy in the recipient's mailbox */
	if (mailtype==M_LOCAL) {
		if (lgetuser(&tempUS,rec)==0) {
			for (e=0; e<(MAILSLOTS-1); ++e) {
				tempUS.mailnum[e]=tempUS.mailnum[e+1];
				tempUS.mailpos[e]=tempUS.mailpos[e+1];
				}
			tempUS.mailnum[MAILSLOTS-1]=smreturn.smnumber;
			tempUS.mailpos[MAILSLOTS-1]=smreturn.smpos;
			lputuser(&tempUS,rec);
			}
		}

	/* if we've posted in a room other than the current room, then we
	   have to now go back to the current room... */
ENTFIN:	if (hold_rm!=(-1)) {
		usergoto(hold_rm,0);
		}
	unlink(mtmp);		/* delete the temporary file */
	}


/*
 * generate an administrative message and post it in the Aide> room
 */
void aide_message(char *text)
{
	long now;
	FILE *fp;

	time(&now);
	fp=fopen(CC->temp,"wb");
	fprintf(fp,"%c%c%c",255,MES_NORMAL,0);
	fprintf(fp,"Psysop%c",0);
	fprintf(fp,"T%ld%c",now,0);
	fprintf(fp,"ACitadel%c",0);
	fprintf(fp,"OAide%c",0);
	fprintf(fp,"N%s%c",NODENAME,0);
	fprintf(fp,"M%s\n%c",text,0);
	fclose(fp);
	save_message(CC->temp,"",1,M_LOCAL,1);
	syslog(LOG_NOTICE,text);
	}



/*
 * build a binary message to be saved on disk
 */
void make_message(char *filename, struct usersupp *author, char *recipient, char *room, int type, int net_type, int format_type, char *fake_name)
                	/* temporary file name */
                          /* author's usersupp structure */
                 	/* NULL if it's not mail */
            		/* room where it's going */
         		/* see MES_ types in header file */
             		/* local or remote type, see citadel.h */
                	/* format type (see citadel.h) */
{ 
	FILE *fp;
	int a;
	long now;
	char dest_node[32];
	char buf[256];

	/* don't confuse the poor folks if it's not routed mail. */
	strcpy(dest_node,"");

	/* if net_type is M_BINARY, split out the destination node */
	if (net_type == M_BINARY) {
		strcpy(dest_node,NODENAME);
		for (a=0; a<strlen(recipient); ++a) {
			if (recipient[a]=='@') {
				recipient[a]=0;
				strcpy(dest_node,&recipient[a+1]);
				}
			}
		}

	/* if net_type is M_INTERNET, set the dest node to 'internet' */
	if (net_type == M_INTERNET) {
		strcpy(dest_node,"internet");
		}

	while (isspace(recipient[strlen(recipient)-1]))
		recipient[strlen(recipient)-1] = 0;

	time(&now);
	fp=fopen(filename,"w");
	putc(255,fp);
	putc(type,fp);	/* Normal or anonymous, see MES_ flags */
	putc(format_type,fp);	/* Formatted or unformatted */
	fprintf(fp,"Pcit%ld%c",author->eternal,0);	/* path */
	fprintf(fp,"T%ld%c",now,0);			/* date/time */
	if (fake_name[0])
	   fprintf(fp,"A%s%c",fake_name,0);
	else
 	   fprintf(fp,"A%s%c",author->fullname,0); 	/* author */
	fprintf(fp,"O%s%c",CC->quickroom.QRname,0); 	/* room */
	fprintf(fp,"N%s%c",NODENAME,0); 		/* nodename */
	fprintf(fp,"H%s%c",HUMANNODE,0); 		/* human nodename */

	if (recipient[0]!=0) fprintf(fp,"R%s%c",recipient,0);
	if (dest_node[0]!=0) fprintf(fp,"D%s%c",dest_node,0);

	putc('M',fp);

	while (client_gets(buf), strcmp(buf,"000"))
	{
	   fprintf(fp,"%s\n",buf);
        }
        syslog(LOG_INFO, "Closing message");
	putc(0,fp);
	fclose(fp);
	}





/*
 * message entry  -  mode 0 (normal) <bc>
 */
void cmd_ent0(char *entargs)
{
	int post = 0;
	char recipient[256];
	int anon_flag = 0;
	int format_type = 0;
	char newusername[256];		/* <bc> */

	int a,b,e;
	int mtsflag = 0;
	struct usersupp tempUS;
	char buf[256];

	post = extract_int(entargs,0);
	extract(recipient,entargs,1);
	anon_flag = extract_int(entargs,2);
	format_type = extract_int(entargs,3);

	/* first check to make sure the request is valid. */

	if (!(CC->logged_in)) {
		cprintf("%d Not logged in.\n",ERROR+NOT_LOGGED_IN);
		return;
		}
	if (CC->curr_rm < 0) {
		cprintf("%d No room selected.\n",ERROR);
		return;
		}
	if ((CC->usersupp.axlevel<2)&&(CC->curr_rm!=1)) {
		cprintf("%d Need to be validated to enter (except in Mail> to sysop)\n",
			ERROR+HIGHER_ACCESS_REQUIRED);
		return;
		}
	if ((CC->usersupp.axlevel<4)&&(CC->quickroom.QRflags&QR_NETWORK)) {
		cprintf("%d Need net privileges to enter here.\n",
			ERROR+HIGHER_ACCESS_REQUIRED);
		return;
		}
	if ((CC->usersupp.axlevel<6)&&(CC->quickroom.QRflags&QR_READONLY)) {
		cprintf("%d Sorry, this is a read-only room.\n",
			ERROR+HIGHER_ACCESS_REQUIRED);
		return;
		}

	mtsflag=0;
	
		
        if (post==2) {			/* <bc> */
           if (CC->usersupp.axlevel<6)
           {
              cprintf("%d\nYou don't have sufficient permission to do an aide post.\n", ERROR+HIGHER_ACCESS_REQUIRED);
              return;
           }
    	   extract(newusername,entargs,4);
    	   bzero(CC->fake_postname, 32);
           strcpy(CC->fake_postname, newusername);
           cprintf("%d\n",OK);
           return;
        }
        
	CC->cs_flags |= CS_POSTING;
	
	buf[0]=0;
	if (CC->curr_rm==1) {
		if (CC->usersupp.axlevel>=2) {
			strcpy(buf,recipient);
			}
		else strcpy(buf,"sysop");
		lprintf(9, "aliasing...\n");
		e=alias(buf);			/* alias and mail type */
		lprintf(9,"...type is %d\n", e);
		if ((buf[0]==0) || (e==M_ERROR)) {
			cprintf("%d Unknown address - cannot send message.\n",
				ERROR+NO_SUCH_USER);
			return;
			}
		if ((e!=M_LOCAL)&&(CC->usersupp.axlevel<4)) {
			cprintf("%d Net privileges required for network mail.\n",
				ERROR+HIGHER_ACCESS_REQUIRED);
			return;
			}
		if ((RESTRICT_INTERNET==1)&&(e==M_INTERNET)
		   &&((CC->usersupp.flags&US_INTERNET)==0)
		   &&(!CC->internal_pgm) ) {
			cprintf("%d You don't have access to Internet mail.\n",
				ERROR+HIGHER_ACCESS_REQUIRED);
			return;
			}
		if (!strucmp(buf,"sysop")) {
			mtsflag=1;
			goto SKFALL;
			}
		if (e!=M_LOCAL) goto SKFALL;	/* don't search local file  */
		if (!strucmp(buf,CC->usersupp.fullname)) {
			cprintf("%d Can't send mail to yourself!\n",
				ERROR+NO_SUCH_USER);
			return;
			}

		/* Check to make sure the user exists; also get the correct
	 	* upper/lower casing of the name. 
	 	*/
		lprintf(9, "checking validity of %s\n", buf);
		a = getuser(&tempUS,buf);
		lprintf(9, "getuser() returned %d\n", a);
		if (a != 0) {
			cprintf("%d No such user.\n",ERROR+NO_SUCH_USER);
			return;
			}
		strcpy(buf,tempUS.fullname);
		}
	
SKFALL: b=MES_NORMAL;
	if (CC->quickroom.QRflags&QR_ANONONLY) b=MES_ANON;
	if (CC->quickroom.QRflags&QR_ANON2) {
		if (anon_flag==1) b=MES_AN2;
		}
	if (CC->curr_rm!=1) buf[0]=0;

	/* If we're only checking the validity of the request, return
	 * success without creating the message.
	 */
	if (post==0) {
		cprintf("%d %s\n",OK,buf);
		return;
		}
	
	cprintf("%d send message\n",SEND_LISTING);
	if (CC->fake_postname[0])
  	   make_message(CC->temp,&CC->usersupp,buf,CC->quickroom.QRname,b,e,format_type, CC->fake_postname);
  	else
  	   if (CC->fake_username[0])
  	      make_message(CC->temp,&CC->usersupp,buf,CC->quickroom.QRname,b,e,format_type, CC->fake_username);
  	   else
  	      make_message(CC->temp,&CC->usersupp,buf,CC->quickroom.QRname,b,e,format_type, "");
	save_message(CC->temp,buf,mtsflag,e,1);
        CC->fake_postname[0]='\0';
	return;
	}



/* 
 * message entry - mode 3 (raw)
 */
void cmd_ent3(char *entargs)
{
	char recp[256];
	char buf[256];
	int a, e;
	struct usersupp tempUS;
	long msglen;
	long bloklen;
	FILE *fp;

	if (CC->internal_pgm == 0) {
		cprintf("%d This command is for internal programs only.\n",
			ERROR);
		return;
		}

	if (CC->curr_rm < 0) {
		cprintf("%d No room selected.\n",ERROR);
		return;
		}

	if (CC->curr_rm == 1) {	/* If we're in Mail, check the recipient */
		extract(recp, entargs, 1);
		lprintf(9, "aliasing...\n");
		e=alias(recp);			/* alias and mail type */
		lprintf(9,"...type is %d\n", e);
		if ((buf[0]==0) || (e==M_ERROR)) {
			cprintf("%d Unknown address - cannot send message.\n",
				ERROR+NO_SUCH_USER);
			return;
			}
		if (e == M_LOCAL) {
			a = getuser(&tempUS,recp);
			if (a!=0) {
				cprintf("%d No such user.\n", ERROR+NO_SUCH_USER);
				return;
				}
			}
		}

	/* At this point, message has been approved. */
	if (extract_int(entargs, 0) == 0) {
		cprintf("%d OK to send\n", OK);
		return;
		}

	/* open a temp file to hold the message */
	fp = fopen(CC->temp, "wb");
	if (fp == NULL) {
		cprintf("%d Cannot open %s: %s\n", 
			ERROR + INTERNAL_ERROR,
			CC->temp, strerror(errno) );
		return;
		}

	msglen = extract_long(entargs, 2);
	cprintf("%d %ld\n", SEND_BINARY, msglen);
	while(msglen > 0L) {
		bloklen = ((msglen >= 255L) ? 255 : msglen);
		client_read(buf, (int)bloklen );
		fwrite(buf, (int)bloklen, 1, fp);
		msglen = msglen - bloklen;
		}
	fclose(fp);

	save_message(CC->temp, recp, 0, e, 0);
	}


/*
 * Delete message from current room
 */
void cmd_dele(char *delstr)
{
	long delnum;
	int a,ok;

	getuser(&CC->usersupp,CC->curr_user);
	if ((CC->usersupp.axlevel < 6)
	   && (CC->usersupp.eternal != CC->quickroom.QRroomaide)) {
		cprintf("%d Higher access required.\n",
			ERROR+HIGHER_ACCESS_REQUIRED);
		return;
		}

	delnum = atol(delstr);
	if (CC->curr_rm==1) {
		cprintf("%d Can't delete mail.\n",ERROR);
		return;
		}
	
	/* get room records, obtaining a lock... */
	lgetroom(&CC->quickroom,CC->curr_rm);
	get_fullroom(&CC->fullroom,CC->curr_rm);

	ok = 0;
	for (a=0; a<MSGSPERRM; ++a)
		if (CC->fullroom.FRnum[a]==delnum) {
			CC->fullroom.FRnum[a]=0L;
			CC->fullroom.FRpos[a]=0L;
			ok = 1;
			}

	sort_fullroom(&CC->fullroom);
	CC->quickroom.QRhighest = CC->fullroom.FRnum[MSGSPERRM-1];

	put_fullroom(&CC->fullroom,CC->curr_rm);
	lputroom(&CC->quickroom,CC->curr_rm);
	if (ok==1) cprintf("%d Message deleted.\n",OK);
	else cprintf("%d No message %ld.\n",ERROR,delnum);
	} 


/*
 * move a message to another room
 */
void cmd_move(char *args)
{
	long num;
	long pos;
	char targ[32];
	int a;
	int targ_slot;
	struct quickroom qtemp;
	struct fullroom ftemp;

	num = extract_long(args,0);
	extract(targ,args,1);
	
	if (CC->curr_rm < 0) {
		cprintf("%d no room\n",ERROR);
		return;
		}

	getuser(&CC->usersupp,CC->curr_user);
	if ((CC->usersupp.axlevel < 6)
	   && (CC->usersupp.eternal != CC->quickroom.QRroomaide)) {
		cprintf("%d Higher access required.\n",
			ERROR+HIGHER_ACCESS_REQUIRED);
		return;
		}

	targ_slot = (-1);
	for (a=0; a<MAXROOMS; ++a) {
		getroom(&qtemp,a);
		if (!strucmp(qtemp.QRname,targ)) {
			targ_slot = a;
			a = MAXROOMS;
			}
		}
	if (targ_slot < 0) {
		cprintf("%d '%s' does not exist.\n",ERROR,targ);
		return;
		}

	/* yank the message out of the current room... */
	lgetroom(&CC->quickroom,CC->curr_rm);
	get_fullroom(&CC->fullroom,CC->curr_rm);

	pos = (-1L);
	for (a=0; a<MSGSPERRM; ++a) {
		if (CC->fullroom.FRnum[a] == num) {
			pos = CC->fullroom.FRpos[a];
			CC->fullroom.FRnum[a] = 0L;
			CC->fullroom.FRpos[a] = 0L;
			}
		}
	if (pos>=0L) {
		sort_fullroom(&CC->fullroom);
		put_fullroom(&CC->fullroom,CC->curr_rm);
		CC->quickroom.QRhighest = CC->fullroom.FRnum[MSGSPERRM-1];
		}
	lputroom(&CC->quickroom,CC->curr_rm);
	if (pos<0L) {
		cprintf("%d msg %ld does not exist\n",ERROR,num);
		return;
		}

	lgetroom(&qtemp,targ_slot);
	get_fullroom(&ftemp,targ_slot);
	for (a=0; a<MSGSPERRM-1; ++a) {
		ftemp.FRnum[a]=ftemp.FRnum[a+1];
		ftemp.FRpos[a]=ftemp.FRpos[a+1];
		}
	ftemp.FRnum[MSGSPERRM-1] = num;
	ftemp.FRpos[MSGSPERRM-1] = pos;
	sort_fullroom(&ftemp);
	qtemp.QRhighest = ftemp.FRnum[MSGSPERRM-1];
	put_fullroom(&ftemp,targ_slot);
	lputroom(&qtemp,targ_slot);
	cprintf("%d ok\n",OK);
	}

