/* 
 * roomstats v1.0
 */

#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <stdargs.h>
#include "citadel.h"

struct ra_list {
	struct ra_list *next;
	char ra_name[30];
	};

int cgi;
int total_users;

/*
 * num_parms()  -  discover number of parameters...
 */
int num_parms(source)
char source[]; {
	int a;
	int count = 1;

	for (a=0; a<strlen(source); ++a) 
		if (source[a]=='|') ++count;
	return(count);
	}


/*
 * extract()  -  extract a parameter from a series of "|" separated...
 */
void extract(dest,source,parmnum)
char dest[];
char source[];
int parmnum; {
	char buf[256];
	int count = 0;
	int n;

	n = num_parms(source);

	if (parmnum >= n) {
		strcpy(dest,"");
		return;
		}
	strcpy(buf,source);
	if ( (parmnum == 0) && (n == 1) ) {
		strcpy(dest,buf);
		return;
		}

	while (count++ < parmnum) do {
		strcpy(buf,&buf[1]);
		} while( (strlen(buf)>0) && (buf[0]!='|') );
	if (buf[0]=='|') strcpy(buf,&buf[1]);
	for (count = 0; count<strlen(buf); ++count)
		if (buf[count] == '|') buf[count] = 0;
	strcpy(dest,buf);
	}

/*
 * extract_int()  -  extract an int parm w/o supplying a buffer
 */
int extract_int(source,parmnum)
char *source;
int parmnum; {
	char buf[256];
	
	extract(buf,source,parmnum);
	return(atoi(buf));
	}


void logoff(code)
int code; {
	exit(code);
	}



/*
 * serv_printf() is like serv_puts() except it can handle formatted strings
 */
void serv_printf(char *format, ...) {   
        va_list arg_ptr;   
        char buf[256];   
        int rc;   
   
        va_start(arg_ptr, format);   
        rc = vsprintf(buf, format, arg_ptr);   
        va_end(arg_ptr);   
   
        serv_puts(buf);   
	}   



/*
 * Duration in d,h,m,s
 */
char *dhms(dur)
long dur; {
	long total;
	static char strbuf[256];
	long days = 0;
	long hours = 0;
	long minutes = 0;
	long seconds = 0;

	total = dur;
	seconds = total % 60;	total = total - seconds;
	minutes = (total % 3600) / 60;
				total = total - (minutes * 60);
	days = (total % 216000) / 3600;
				total = total - (minutes * 3600);

	sprintf(strbuf,"%ld days, %ld hours, %ld minutes, %ld seconds",
		days, hours, minutes, seconds);
	return(strbuf);
	}


/*
 * fmout()  -  Citadel text formatter and paginator
 */
void 
fmout (fp)
     FILE *fp;		/* file to read from, or NULL to read from server */
{
  int width = 80;
  int a, b, c, d, old;
  int real = (-1);
  char aaa[140];
  char buffer[512];
  int eof_flag = 0;

  if (cgi)
    printf ("<EM>");
  strcpy (aaa, "");
  old = 255;
  strcpy (buffer, "");
  c = 1;			/* c is the current pos */

FMTA:while ((eof_flag == 0) && (strlen (buffer) < 126))
    {
      if (fp != NULL)
	{			/* read from file */
	  if (feof (fp))
	    eof_flag = 1;
	  if (eof_flag == 0)
	    {
	      a = getc (fp);
	      buffer[strlen (buffer) + 1] = 0;
	      buffer[strlen (buffer)] = a;
	    }
	}
      else
	{			/* read from server */
	  d = strlen (buffer);
	  serv_gets (&buffer[d]);
	  while ((!isspace (buffer[d])) && (isspace (buffer[strlen (buffer) - 1])))
	    buffer[strlen (buffer) - 1] = 0;
	  if (!strcmp (&buffer[d], "000"))
	    {
	      buffer[d] = 0;
	      eof_flag = 1;
	      while (isspace (buffer[strlen (buffer) - 1]))
		buffer[strlen (buffer) - 1] = 0;
	    }
	  d = strlen (buffer);
	  buffer[d] = 10;
	  buffer[d + 1] = 0;
	}
    }

  buffer[strlen (buffer) + 1] = 0;
  a = buffer[0];
  strcpy (buffer, &buffer[1]);

  old = real;
  real = a;
  if (a <= 0)
    goto FMTEND;

  if (((a == 13) || (a == 10)) && (old != 13) && (old != 10))
    a = 32;
  if (((old == 13) || (old == 10)) && (isspace (real)))
    {
      if (cgi)
	printf ("<BR>");
      printf ("\n");
      c = 1;
    }
  if (a > 126)
    goto FMTA;

  if (a > 32)
    {
      if (((strlen (aaa) + c) > (width - 5)) && (strlen (aaa) > (width - 5)))
	{
	  printf ("\n%s", aaa);
	  c = strlen (aaa);
	  aaa[0] = 0;
	}
      b = strlen (aaa);
      aaa[b] = a;
      aaa[b + 1] = 0;
    }
  if (a == 32)
    {
      if ((strlen (aaa) + c) > (width - 5))
	{
	  c = 1;
	  printf ("\n");
	}
      printf ("%s ", aaa);
      ++c;
      c = c + strlen (aaa);
      strcpy (aaa, "");
      goto FMTA;
    }
  if ((a == 13) || (a == 10))
    {
      printf ("%s\n", aaa);
      c = 1;
      strcpy (aaa, "");
      goto FMTA;
    }
  goto FMTA;

FMTEND:printf ("\n");
  if (cgi)
    printf ("</EM><BR>");
}


void TellMeAbout(RoomName)
char *RoomName; {
	char buf[256];
	unsigned RoomFlags = 0;
	char password[10];
	char directory[20];
	char RoomAide[30];
	long msg[MSGSPERRM];
	int count = 0;
	int a;
	long earliest = 0L;
	long latest = 0L;
	long MsgTime;
	long avg_msg_len = 0L;
	int in_msg = 0;
	int room_users;

	for (a=0; a<MSGSPERRM; ++a) {
		msg[a] = 0L;
		}

	if (cgi) {
		printf("<CENTER><H1>%s</H1></CENTER>\n",RoomName);
		}
	else {
		printf("Room Name: %s\n",RoomName);
		}

	serv_printf("GOTO %s",RoomName);
	serv_gets(buf);
	if (buf[0]!='2') {
		printf("%s\n",buf);
		if (cgi) printf("<BR>");
		return;
		}

	serv_puts("RINF");
	serv_gets(buf);
	if (buf[0]=='1') fmout(NULL);

	serv_puts("GETR");
	serv_gets(buf);
	if (buf[0]!='2') return;

	extract(password,buf,1);
	extract(directory,buf,2);
	RoomFlags = extract_int(buf,3);

	if (RoomFlags & QR_PRIVATE) {
		printf("Private: ");
		if (cgi) printf("<EM>");
		if (((RoomFlags & QR_PASSWORDED)==0)
		   &&((RoomFlags & QR_GUESSNAME)==0)) {
			printf("Invitation-Only");
			}
		if (RoomFlags & QR_PASSWORDED) {
			printf("Password=%s",password);
			}
		if (RoomFlags & QR_GUESSNAME) {
			printf("Guess-Name");
			}
		if (cgi) printf("</EM>");
		}
	else {
		printf("Public room");
		}
	
	if (cgi) printf("<BR>");
	printf("\n");

	if (RoomFlags & QR_DIRECTORY) {
		printf("Directory Name: ");
		if (cgi) printf("<TT>");
		printf("%s",directory);
		if (cgi) printf("</TT>");
		printf("\n");
		if (cgi) printf("<BR>");
		if (RoomFlags & QR_UPLOAD) printf("Uploading allowed.  ");
		if (RoomFlags & QR_DOWNLOAD) printf("Downloading allowed.  ");
		if (RoomFlags & QR_VISDIR) printf("Visible directory.  ");
		if (RoomFlags & (QR_UPLOAD|QR_DOWNLOAD|QR_VISDIR)) {
			if (cgi) printf("<BR>");
			printf("\n");
			}
		}
	else {
		printf("No directory.\n");
		if (cgi) printf("<BR>");
		}

	if (RoomFlags & QR_ANONONLY) printf("Anonymous messages only.  ");
	if (RoomFlags & QR_ANON2) printf("Anonymous message option.  ");
	if (RoomFlags & QR_NETWORK) printf("Network shared room.  ");
	if (RoomFlags & QR_PREFONLY) printf("Preferred users only.  ");
	if (RoomFlags & QR_READONLY) printf("Read-only room.  ");
	if (RoomFlags & QR_PERMANENT) printf("Permanent room.  ");
	if (RoomFlags & (QR_ANONONLY|QR_ANON2|QR_NETWORK|QR_PREFONLY|QR_READONLY|QR_PERMANENT)) {
		printf("\n");
		if (cgi) printf("<BR>");
		}


	serv_puts("GETA");
	serv_gets(buf);
	if (buf[0]=='2') {
		extract(RoomAide,&buf[4],0);
		}
	else {
		strcpy(RoomAide,"");
		}
	if (strlen(RoomAide)>0) {
		printf("Room Aide: %s\n",RoomAide);
		if (cgi) printf("<BR>");
		}

	serv_puts("MSGS ALL");
	serv_gets(buf);
	if (buf[0]!='1') return;

	while (serv_gets(buf), strcmp(buf,"000")) {
		msg[count++] = atol(buf);
		}


	for (a=0; a<count; ++a) {
		serv_printf("MSG0 %ld",msg[a]);
		serv_gets(buf);
		if (buf[0]=='1') while (serv_gets(buf), strcmp(buf,"000")) {
		

			if (!strncmp(buf,"time=",5)) {
				MsgTime = atol(&buf[5]);
				if ((MsgTime < earliest) || (earliest == 0L)) 
					earliest = MsgTime;
				if (MsgTime > latest) 
					latest = MsgTime;
				}
			if (!strncmp(buf,"text",4)) in_msg = 1;
			if (in_msg) avg_msg_len = avg_msg_len + (long)strlen(buf) +1L;

			}
		}

	if (avg_msg_len > 0L) {
		avg_msg_len = avg_msg_len / (int)count;
		}
	else {	
		avg_msg_len = 0L;
		}
	MsgTime = latest - earliest;

	printf("Room contains %d messages.\n",count);
	if (cgi) printf("<BR>");
	printf("Messages span %s\n",dhms(MsgTime));
	if (cgi) printf("<BR>");
	printf("Average message length: %ld\n",avg_msg_len);
	if (cgi) printf("<BR>");

	room_users = 0;
	serv_puts("WHOK");
	serv_gets(buf);
	if (buf[0]=='1') {
		while (serv_gets(buf), strcmp(buf,"000")) {
			++room_users;
			}
		}
	printf("This room is known by %d of %d users \n",
		room_users,total_users);
	if (total_users != 0) {
		printf("(%d%%)",((room_users*100)/total_users));
		}
	printf(".\n");
	if (cgi) printf("<BR>");
	}


void DoList() {
	char buf[256];
	struct ra_list *ra = NULL;
	struct ra_list *mr = NULL;
	struct ra_list *ptr;

	/* build the list */
	sprintf(buf,"LKRA");
	serv_puts(buf);
	serv_gets(buf);
	if (buf[0]!='1') return;

	while (serv_gets(buf), strcmp(buf,"000")) {
		ptr = (struct ra_list *) malloc(sizeof(struct ra_list));
		ptr-> next = NULL;
		extract(ptr->ra_name,buf,0);
		if (mr == NULL) {
			ra = ptr;
			mr = ptr;
			}
		else {
			mr->next = ptr;
			mr = ptr;
			}
		}

	/* one by one... */
	for (ptr = ra; ptr!=NULL; ptr=ptr->next) {
		if (cgi) {
			printf("<HR>\n");
			}
		else {
			printf(" ----------------------------------------");
			printf("--------------------------------------\n");
			}
		TellMeAbout(ptr->ra_name);
		}

	/* free the list */
	while (ra != NULL) {
		ptr = ra->next;
		free(ra);
		ra = ptr;
		}

	}


/*
 * count the total number of users on the system
 */
void CountUsers() {
	char buf[256];
	
	total_users = 0;
	serv_puts("LIST");
	serv_gets(buf);
	if (buf[0]!='1') return;
	while (serv_gets(buf), strcmp(buf,"000")) {
		++total_users;
		}
	}



main(argc,argv)
int argc;
char *argv[]; {
	char buf[256];
	int a;

	/* values for cgi:
	 * 0 = Standalone report - plain text output
	 * 1 = Run as a cgi-bin - HTML output
	 */
	cgi = 0;

	/*
	 * We are running as a cgi-bin if the environment variable
	 * SERVER_NAME is defined.  If this doesn't work correctly for you,
	 * find some other variable that your Webserver sets.
	 */
	if (getenv("SERVER_NAME")!=NULL) cgi = 1;

	if (cgi) {
		printf("Content-type: text/html\n\n");
		printf("<HTML><HEAD><TITLE>Room Stats</TITLE></HEAD><BODY>\n");
		printf("<H1>Room Stats</H1>\n");
		}

	attach_to_server(argc,argv);
	serv_gets(buf);
	if ((buf[0]!='2')&&(strncmp(buf,"551",3))) {
		fprintf(stderr,"%s: %s\n",argv[0],&buf[4]);
		logoff(atoi(buf));
		}


	sprintf(buf,"IPGM %d", config.c_ipgm_secret);
	serv_puts(buf);
	serv_gets(buf);

	if (buf[0]=='2') {
		CountUsers();
		DoList();
		}

	serv_puts("QUIT");
	serv_gets(buf);

	if (cgi) {
		printf("</BODY></HTML>\n");
		}

	exit(0);
	}
