#include "sysdep.h"
#include <stdio.h>

struct ra_list {
	struct ra_list *next;
	char ra_name[30];
	char ra_aide[30];
	};


/*
 * num_parms()  -  discover number of parameters...
 */
int num_parms(source)
char source[]; {
	int a;
	int count = 1;

	for (a=0; a<strlen(source); ++a) 
		if (source[a]=='|') ++count;
	return(count);
	}


/*
 * extract()  -  extract a parameter from a series of "|" separated...
 */
void extract(dest,source,parmnum)
char dest[];
char source[];
int parmnum; {
	char buf[256];
	int count = 0;
	int n;

	n = num_parms(source);

	if (parmnum >= n) {
		strcpy(dest,"");
		return;
		}
	strcpy(buf,source);
	if ( (parmnum == 0) && (n == 1) ) {
		strcpy(dest,buf);
		return;
		}

	while (count++ < parmnum) do {
		strcpy(buf,&buf[1]);
		} while( (strlen(buf)>0) && (buf[0]!='|') );
	if (buf[0]=='|') strcpy(buf,&buf[1]);
	for (count = 0; count<strlen(buf); ++count)
		if (buf[count] == '|') buf[count] = 0;
	strcpy(dest,buf);
	}

/*
 * extract_int()  -  extract an int parm w/o supplying a buffer
 */
int extract_int(source,parmnum)
char *source;
int parmnum; {
	char buf[256];
	
	extract(buf,source,parmnum);
	return(atoi(buf));
	}


void logoff(code)
int code; {
	exit(code);
	}



void do_list() {
	char buf[256];
	struct ra_list *ra = NULL;
	struct ra_list *mr = NULL;
	struct ra_list *ptr;

	sprintf(buf,"LKRA");
	serv_puts(buf);
	serv_gets(buf);
	if (buf[0]!='1') return;

	while (serv_gets(buf), strcmp(buf,"000")) {
		ptr = (struct ra_list *) malloc(sizeof(struct ra_list));
		ptr-> next = NULL;
		extract(ptr->ra_name,buf,0);
		strcpy(ptr->ra_aide,"");
		if (mr == NULL) {
			ra = ptr;
			mr = ptr;
			}
		else {
			mr->next = ptr;
			mr = ptr;
			}
		}

	for (ptr = ra; ptr!=NULL; ptr=ptr->next) {
		sprintf(buf,"GOTO %s",ptr->ra_name);
		serv_puts(buf);
		serv_gets(buf);
		if (buf[0]=='2') {
			serv_puts("GETA");
			serv_gets(buf);
			if (buf[0]=='2') {
				extract(ptr->ra_aide,&buf[4],0);
				}
			}
		}


	while (ra != NULL) {
		printf("%30s : %s\n",ra->ra_name,ra->ra_aide);
		ptr = ra->next;
		free(ra);
		ra = ptr;
		}

	}


main(argc,argv)
int argc;
char *argv[]; {
	char buf[256];
	int a;
	int cmd = 0;

	for (a=0; a<argc; ++a) {
		if (!strcmp(argv[a],"-roomaides")) cmd = 1;
		}

	if (cmd == 0) {
		fprintf(stderr,"%s: no valid command specified\n",argv[0]);
		fprintf(stderr," Available commands are: \n");
		fprintf(stderr,"  -roomaides  List room aides for each room\n");
		exit(1);
		}

	attach_to_server(argc,argv);
	serv_gets(buf);
	if ((buf[0]!='2')&&(strncmp(buf,"551",3))) {
		fprintf(stderr,"%s: %s\n",argv[0],&buf[4]);
		logoff(atoi(buf));
		}


	sprintf(buf,"IPGM %d", config.c_ipgm_secret);
	serv_puts(buf);
	serv_gets(buf);
	
	if (buf[0]=='2') switch(cmd) {
		case 1:	do_list();
			break;
		}

	serv_puts("QUIT");
	serv_gets(buf);
	exit(0);
	}
