/* Citadel/UX sysop utilities v3.8
 * The software assumes that if any user who has access to this program is
 * allowed to use the sysop utilities. Make sure that the permissions
 * are correct for this.
 */

#define CLN (5184000L)		/* user purge time */
#define RLN (1209600L)		/* room purge time */

#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <time.h>
#include "citadel.h"

void get_config();
struct config config;
extern char bbs_home_directory[];
extern int home_specified;

int hash(str)
char str[]; {
	int h = 0;
	int i;

	for (i=0; i<strlen(str); ++i) h=h+((i+1)*tolower(str[i]));
	return(h);
	}

void pwcrypt(text,code)
char text[];
int code; {
	int a;
	for (a=0; a<strlen(text); ++a) text[a]=(text[a]^(((code|128)^a)&0xFF));
	}

int struncmp(lstr,rstr,len)
char lstr[],rstr[];
int len; {
	int pos = 0;
	char lc,rc;
	while (pos<len) {
		lc=tolower(lstr[pos]);
		rc=tolower(rstr[pos]);
		if ((lc==0)&&(rc==0)) return(0);
		if (lc<rc) return(-1);
		if (lc>rc) return(1);
		pos=pos+1;
		}
	return(0);
	}


void write_hashtab() {
	struct usersupp u;
	int h;
	int in,out;
	
	in=open("usersupp",O_RDONLY);
	out=creat("hashtab",0600);
	while(read(in,&u,sizeof(struct usersupp))) {
		h=hash(u.fullname);
		write(out,&h,sizeof(int));
		}
	close(in);
	close(out);
	}

/*
 * sort the userlog
 */
void sortlog(filename,how)
char *filename;
int how; {
	char aaa[100];
	struct usersupp rec1;
	struct usersupp rec2;
	int file;
	long aa,cc,dd,nrecs;

	system("clear");
	sprintf(aaa,"cp %s usersupp.bak",filename);
	system(aaa);
	file=open(filename,O_RDWR);
	if (file<0) return;
	aa=lseek(file,0L,2); nrecs=(aa/sizeof(struct usersupp));
	for (cc=0; cc<nrecs; ++cc) {
		printf("Sorted %5ld of %5ld records.\n",cc,nrecs);
		for (dd=(nrecs-1L); dd>cc; --dd) {
			aa=((dd-1L)*sizeof(struct usersupp));
			lseek(file,aa,0);
			read(file,&rec1,sizeof(struct usersupp));
			read(file,&rec2,sizeof(struct usersupp));
		    if ( ((how==0)&&(strucmp(rec1.fullname,rec2.fullname)>0))
			|| ((how==1)&&(rec1.eternal>rec2.eternal))) {
				lseek(file,aa,0);
				write(file,&rec2,sizeof(struct usersupp));
				write(file,&rec1,sizeof(struct usersupp));
				}
			}
		}
	close(file);
	}


void userpurge() {	/* removes anyone who hasn't called in 2 months */
	FILE *fp1;
	char aaa[100];
	struct usersupp usersupp;
	long now,call,pos;
	FILE *post;
	int purge;

	post=(FILE *)popen("./aidepost","w");
	if (post==NULL) post=(FILE *)popen("cat >/dev/null","w");
	fprintf(post,"The following users have not called in the past %ld seconds\n",
			CLN);
	fprintf(post,"or have been marked for deletion, and have been purged:\n");
	time(&now);
	printf("userpurge: <<  Purging user file   >>\n");
	fp1=fopen("usersupp","rb+");
	if (fp1==NULL) {
		printf("Cannot open usersupp.\n");
		return;
		}
	while (pos=ftell(fp1),
	      fread((char *)&usersupp,sizeof(struct usersupp),1,fp1)==1) {
		call=now-(usersupp.lastcall);
		strcpy(aaa,usersupp.password);
		pwcrypt(aaa,PWCRYPT);

/** BEGIN USER PURGING RULESET **
 This set of rules determines whether or not to purge a user from the
 userlog.  The rules are evaluated linearly; setting the 'purge' value to
 0 (don't purge) or 1 (purge) in a rule will override any decision that was
 previously made in an earlier rule.
 */
		/* The default rule is, of course, to not purge. */
		purge = 0;

		/* If the user hasn't called in two months, his/her account
		 * has expired, so purge the record. */
		if (call > CLN) purge = 1;

		/* If the user set his/her password to 'deleteme', he/she
		 * wishes to be deleted, so purge the record. */
		if (!strucmp(aaa,"deleteme")) purge = 1;

		/* If the record is marked as permanent, don't purge it. */
		if (usersupp.flags & US_PERM) purge = 0;

		/* If a Citadel account is attached to a Unix account,
		 * don't purge the record. */
		if (usersupp.USuid != BBSUID) purge = 0;

		/* 0 calls is impossible.  If there are 0 calls, it must
		 * be a corrupted record, so purge it. */
		if (usersupp.timescalled == 0) purge = 1;

		/* If a record is already marked as deleted, don't bother
		 * wasting resources by deleting it again. */
		if (usersupp.axlevel == 0) purge = 0;

/** END USER PURGING RULESET **/

		if (purge) {
			usersupp.axlevel = 0;
			fseek(fp1, pos, 0);
	      		fwrite((char *)&usersupp,sizeof(struct usersupp),1,fp1);
			printf("           #%-5ld %s\n",
				usersupp.eternal,usersupp.fullname);
			fprintf(post,"           #%-5ld %s\n",
				usersupp.eternal,usersupp.fullname);
			}
		}
	fclose(fp1);
	pclose(post);

	return;
	}


/*
 * remove any rooms which have not been accessed in 2 weeks
 */
void roompurge() {
	int file,a,b;
	char fname[50];
	long act,now;
	FILE *post;
	struct stat sbuf;
	struct quickroom quickroom;

	post=(FILE *)popen("./aidepost","w");
	if (post==NULL) post=(FILE *)popen("cat >/dev/null","w");
	fprintf(post,
		"The following rooms have not been used for %ld seconds\n",RLN);
	fprintf(post,"and have been deleted from the room files:\n");
	time(&now);

	file=open("quickroom",O_RDWR);
	for (a=0; a<MAXROOMS; ++a) {
		sprintf(fname,"./rooms/fullrm%d",a);
		b=stat(fname,&sbuf);
		act=now-(long)sbuf.st_mtime;
		read(file,&quickroom,sizeof(struct quickroom));
		if ((a>2)&&(quickroom.QRflags&QR_INUSE)&&(act>RLN)&&(b>=0)
			&&((quickroom.QRflags&QR_NETWORK)==0)
			&&((quickroom.QRflags&QR_PERMANENT)==0)
			&&((quickroom.QRflags&QR_DIRECTORY)==0)) {

			quickroom.QRflags=quickroom.QRflags-QR_INUSE;
			lseek(file,(long)a*sizeof(struct quickroom),0);
			write(file,&quickroom,sizeof(struct quickroom));
			printf("roompurge: %20s deleted %ld\n",
				quickroom.QRname,act);
			fprintf(post,"%s\n",quickroom.QRname);
			}	
		}
	close(file);
	pclose(post);
	}


void main(argc,argv) 
int argc;
char *argv[];
{
	int a;
	char aaa[100];

	get_config();

	if (argc>1) {
		if (!strcmp(argv[1],"-u")) {
			userpurge();
			exit(0);
			}
		if (!strcmp(argv[1],"-r")) {
			roompurge();
			exit(0);
			}
		if (!strcmp(argv[1],"-h")) {
			write_hashtab();
			exit(0);
			}
		}

while(1) {
	printf("\n\n\n\n\n\n\n\n\n\n\n\n");
	printf("%s\nCitadel/UX Sysop Utilities\n\n",HUMANNODE);
	printf(" 1. Purge old rooms\n");
	printf(" 2. \n");
	printf(" 3. Write userlog hash table\n");
	printf(" 4. \n");
	printf(" 5. Sort the userlog by User ID\n");
	printf(" 6. Sort the userlog by login name\n");
	printf(" 7. Purge old users\n");
	printf(" 8. Select a different BBS directory\n");
	printf(" 9. Quit\n");
	printf("\n\n\n\n\n\n\n\n\n\n\n");
	printf(" Please enter your selection: ");
	fgets(aaa, 100, stdin);
	a=atoi(aaa);

	switch(a) {
	   case 1:	roompurge();
			break;
	   case 3:	write_hashtab();
			break;
	   case 5:	sortlog("usersupp",1);
			write_hashtab();
			break;
	   case 6:	sortlog("usersupp",0);
			write_hashtab();
			break;
	   case 7:	userpurge();
			break;
	   case 8:	printf("Enter new directory: ");
			gets(bbs_home_directory);
			home_specified = 1;
			get_config();
			break;
	   case 9:	exit(0);
	   default:	printf("Selection not available\n");
	   	}
 	    }
	}

